package nc.impl.gl.voucher;

package ..deTemp.1731576570549;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Vector;
import javax.naming.NamingException;
import nc.bs.dao.BaseDAO;
import nc.bs.gl.voucher.VoucherBO;
import nc.bs.gl.voucher.VoucherCheckBO;
import nc.bs.gl.voucher.VoucherExtendDMO;
import nc.bs.glcom.ass.FreevalueBO;
import nc.bs.ml.NCLangResOnserver;
import nc.bs.pub.SystemException;
import nc.itf.gl.voucher.IVoucher;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.jdbc.framework.processor.VectorProcessor;
import nc.vo.gl.accountcomp.AccountCompBVO;
import nc.vo.gl.pubvoucher.OperationResultVO;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.gl.voucher.VoucherCheckConfigVO;
import nc.vo.gl.voucherquery.VoucherQueryConditionVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;

public class ImpVoucher implements IVoucher {
  public OperationResultVO[] save(VoucherVO arg0, Boolean arg1) throws BusinessException {
    return (new VoucherBO()).save(arg0, arg1);
  }
  
  public OperationResultVO[] save(VoucherVO arg0, VoucherCheckConfigVO arg1, Object arg2) throws BusinessException {
    return (new VoucherBO()).save(arg0, arg1, arg2);
  }
  
  public OperationResultVO[] delete(VoucherVO arg0) throws BusinessException {
    return (new VoucherBO()).delete(arg0);
  }
  
  public VoucherVO[] queryAll(String arg0) throws BusinessException {
    return (new VoucherBO()).queryAll(arg0);
  }
  
  public VoucherVO[] queryByVO(VoucherVO arg0, Boolean arg1) throws BusinessException {
    return (new VoucherBO()).queryByVO(arg0, arg1);
  }
  
  public Boolean isExistRegulationVoucher(String arg0, String arg1, String arg2) throws BusinessException {
    return (new VoucherBO()).isExistRegulationVoucher(arg0, arg1, arg2);
  }
  
  public VoucherVO findByPrimaryKey(String arg0) throws BusinessException {
    return (new VoucherBO()).findByPrimaryKey(arg0);
  }
  
  public VoucherVO[] queryByPks(String[] arg0) throws BusinessException {
    return (new VoucherBO()).queryByPks(arg0);
  }
  
  public VoucherVO queryByPk(String arg0) throws BusinessException {
    return (new VoucherBO()).queryByPk(arg0);
  }
  
  public OperationResultVO[] abandonByPks(String[] arg0, String arg1, Boolean arg2) throws BusinessException {
    return (new VoucherBO()).abandonByPks(arg0, arg1, arg2);
  }
  
  public Integer getCorrectVoucherNo(VoucherVO arg0) throws BusinessException {
    return (new VoucherBO()).getCorrectVoucherNo(arg0);
  }
  
  public VoucherVO[] catVouchers(VoucherVO[] arg0) throws BusinessException {
    return (new VoucherBO()).catVouchers(arg0);
  }
  
  public void copyVoucher(VoucherVO arg0, Integer arg1) throws BusinessException {
    (new VoucherBO()).copyVoucher(arg0, arg1);
  }
  
  public void copyVoucherUnChecked(VoucherVO arg0, Integer arg1) throws BusinessException {
    (new VoucherBO()).copyVoucherUnChecked(arg0, arg1);
  }
  
  public OperationResultVO deleteByPk(String arg0) throws BusinessException {
    return (new VoucherBO()).deleteByPk(arg0);
  }
  
  public OperationResultVO deleteByPk(String arg0, Boolean arg1) throws BusinessException {
    return (new VoucherBO()).deleteByPk(arg0, arg1);
  }
  
  public OperationResultVO deleteByPks(String[] arg0, String arg1) throws BusinessException {
    return (new VoucherBO()).deleteByPks(arg0, arg1);
  }
  
  public VoucherVO[] queryByConditionVO(VoucherQueryConditionVO[] arg0, Boolean arg1) throws BusinessException {
    return (new VoucherBO()).queryByConditionVO(arg0, arg1);
  }
  
  public OperationResultVO[] saveError(VoucherVO arg0) throws BusinessException {
    return (new VoucherBO()).saveError(arg0);
  }
  
  public boolean isOfferSetVoucher(String pk_voucher) throws BusinessException {
    try {
      return (new VoucherExtendDMO()).isOfferSetVoucher(pk_voucher);
    } catch (SystemException e) {
      throw new BusinessException(e.getMessage());
    } catch (SQLException e) {
      throw new BusinessException(e.getMessage());
    } catch (NamingException e) {
      throw new BusinessException(e.getMessage());
    } 
  }
  
  public String getDesOfferDetail(String pk_accsubj, String pk_offerdetail) throws BusinessException {
    try {
      return (new VoucherExtendDMO()).getDesOfferDetail(pk_accsubj, pk_offerdetail);
    } catch (SystemException e) {
      throw new BusinessException(e.getMessage());
    } catch (SQLException e) {
      throw new BusinessException(e.getMessage());
    } catch (NamingException e) {
      throw new BusinessException(e.getMessage());
    } 
  }
  
  public void reloadVoucherUser(String pk_glorgbook) throws BusinessException {
    (new VoucherBO()).reloadVoucherUser(pk_glorgbook);
  }
  
  public boolean updateVoucherDifflag(String[] pk_vouchers, UFBoolean direction) throws BusinessException {
    return (new VoucherBO()).updateVoucherDifflag(pk_vouchers, direction);
  }
  
  public boolean isVerifyVoucher(String pk_voucher) throws BusinessException {
    try {
      return (new VoucherExtendDMO()).isVerifyVoucher(pk_voucher);
    } catch (SystemException e) {
      throw new BusinessException(e.getMessage());
    } catch (SQLException e) {
      throw new BusinessException(e.getMessage());
    } catch (NamingException e) {
      throw new BusinessException(e.getMessage());
    } 
  }
  
  public boolean isVerifyDetail(String pk_detail) throws BusinessException {
    try {
      return (new VoucherExtendDMO()).isVerifyDetail(pk_detail);
    } catch (SystemException e) {
      throw new BusinessException(e.getMessage());
    } catch (SQLException e) {
      throw new BusinessException(e.getMessage());
    } catch (NamingException e) {
      throw new BusinessException(e.getMessage());
    } 
  }
  
  public VoucherVO[] catBridgeVouchers(VoucherVO[] vouchers) throws BusinessException {
    return (new VoucherBO()).catBridgeVouchers(vouchers);
  }
  
  public AccountCompBVO[] getAccountCompBVO(String orgbook, String type, String pk_subj, String direction) throws BusinessException {
    BaseDAO dao = new BaseDAO();
    String sqlwhere = "";
    sqlwhere = " and b.source ='" + pk_subj + "'";
    String sql = "select b.pk_accountcomp_b,       b.pk_accountcomp,       b.rowno,       b.source,       b.srcassid,       b.srcassname,       b.srcdirection,       b.pripose,       b.priassid,       b.priassname,       b.pridirection,       b.valuemessage  from fipub_accountcomp a  left join fipub_accountcomp_b b    on a.pk_accountcomp = b.pk_accountcomp where a.accounting = '" + orgbook + "'   and a.classify = '" + type + "'   and a.dr=0   and isnull(b.dr,0)=0" + sqlwhere + " order by b.rowno asc";
    Vector<Vector> o1 = (Vector)dao.executeQuery(sql, (ResultSetProcessor)new VectorProcessor());
    AccountCompBVO[] vos = null;
    if (o1.size() > 0 && o1 != null) {
      vos = new AccountCompBVO[o1.size()];
      for (int i = 0; i < o1.size(); i++) {
        String pk_accountcomp_b = new String((((Vector)o1.elementAt(i)).elementAt(0) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(0).toString() : "");
        String pk_accountcomp = new String((((Vector)o1.elementAt(i)).elementAt(1) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(1).toString() : "");
        Integer rowno = new Integer((((Vector)o1.elementAt(i)).elementAt(2) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(2).toString() : "");
        String source = new String((((Vector)o1.elementAt(i)).elementAt(3) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(3).toString() : "");
        String srcassid = new String((((Vector)o1.elementAt(i)).elementAt(4) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(4).toString() : "");
        String srcassname = new String((((Vector)o1.elementAt(i)).elementAt(5) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(5).toString() : "");
        String srcdirection = new String((((Vector)o1.elementAt(i)).elementAt(6) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(6).toString() : "");
        String pripose = new String((((Vector)o1.elementAt(i)).elementAt(7) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(7).toString() : "");
        String priassid = new String((((Vector)o1.elementAt(i)).elementAt(8) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(8).toString() : "");
        String priassname = new String((((Vector)o1.elementAt(i)).elementAt(9) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(9).toString() : "");
        String pridirection = new String((((Vector)o1.elementAt(i)).elementAt(10) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(10).toString() : "");
        String valuemessage = new String((((Vector)o1.elementAt(i)).elementAt(11) != null) ? ((Vector<E>)o1.elementAt(i)).elementAt(11).toString() : "");
        vos[i] = new AccountCompBVO();
        vos[i].setPk_accountcomp_b(pk_accountcomp_b);
        vos[i].setPk_accountcomp(pk_accountcomp);
        vos[i].setRowno(rowno);
        vos[i].setSource(source);
        vos[i].setSrcassid(srcassid);
        vos[i].setSrcassname(srcassname);
        vos[i].setSrcdirection(srcdirection);
        vos[i].setPripose(pripose);
        vos[i].setPriassid(priassid);
        vos[i].setPriassname(priassname);
        vos[i].setPridirection(pridirection);
        vos[i].setValuemessage(valuemessage);
        vos[i].setSrcassVOs((new FreevalueBO()).queryAll(srcassid));
        vos[i].setPriassVOs((new FreevalueBO()).queryAll(priassid));
      } 
    } 
    return vos;
  }
  
  public AccountCompBVO[] getAccountCompBVO(String orgbook, String type, String[] pk_subjs) throws BusinessException {
    ArrayList<AccountCompBVO> list = new ArrayList<>();
    for (int i = 0; i < pk_subjs.length; i++) {
      AccountCompBVO[] bvos1 = getAccountCompBVO(orgbook, type, pk_subjs[i], "");
      if (bvos1 != null)
        for (int j = 0; j < bvos1.length; j++)
          list.add(bvos1[j]);  
    } 
    return list.<AccountCompBVO>toArray(new AccountCompBVO[0]);
  }
  
  public void checkSubjRule(VoucherVO voucher) throws Exception {
    voucher.clearDetail();
    OperationResultVO[] checkresult = (new VoucherCheckBO()).checkVoucher(voucher, new VoucherCheckConfigVO());
    if (checkresult != null) {
      StringBuffer strMsg = new StringBuffer();
      boolean errflag = false;
      for (int i = 0; i < checkresult.length; i++) {
        switch ((checkresult[i]).m_intSuccess) {
          case 0:
            break;
          case 1:
            strMsg.append(NCLangResOnserver.getInstance().getStrByID("2002100556", "UPP2002100556-000119") + (checkresult[i]).m_strDescription + "\n");
            break;
          case 2:
            errflag = true;
            strMsg.append(NCLangResOnserver.getInstance().getStrByID("2002100556", "UPP2002100556-000120") + (checkresult[i]).m_strDescription + "\n");
            break;
          default:
            strMsg.append(NCLangResOnserver.getInstance().getStrByID("2002100556", "UPP2002100556-000121") + (checkresult[i]).m_strDescription + "\n");
            break;
        } 
      } 
      if (strMsg.length() > 0 && errflag)
        throw new Exception(strMsg.toString()); 
    } 
  }
  
  public void updatePrintCount(String[] pk_vouchers) throws Exception {
    VoucherBO bo = new VoucherBO();
    bo.updatePrintCount(pk_vouchers);
  }
  
  public String[] batchDiffAnalyze(String[] pk_vouchers, String type) throws BusinessException {
    VoucherBO bo = new VoucherBO();
    return bo.batchDiffAnalyze(pk_vouchers, type);
  }
}
